package se.lth.cs.dkinterface.model;

import java.util.Vector;

public class AbstractModel
{
  private String modelName; 
  private Vector<ModelListener> listeners = new Vector<ModelListener>();
 
  protected void setModelName(String name)
  {
    modelName = name;
  }
  
  public String getModelName()
  {
    return modelName;
  }  
  
  public void addModelListener(ModelListener listener)
  {
    listeners.add(listener);
  }
  
  protected void fireModelChanged()
  {
    for(ModelListener listener : listeners)
    {
      listener.modelChanged(this);
    }
  }
}
