package se.lth.cs.dkinterface.model;

import java.util.Vector;

import javax.swing.ListModel;
import javax.swing.event.ListDataEvent;
import javax.swing.event.ListDataListener;

import se.lth.cs.dkinterface.services.connection.ConnectionListener;
import se.lth.cs.dkinterface.services.connection.ConnectionServices;
import se.lth.cs.dkserver.services.server.command.Request;

public class PropertiesModel extends AbstractModel implements ConnectionListener, ListModel
{
  public static final String NAME = "PropertiesModel";
  
  private final ConnectionServices connectionServices;
  private Vector<String> properties = new Vector<String>();
  private final Vector<ListDataListener> listeners = new Vector<ListDataListener>();
  
  public PropertiesModel(ConnectionServices connectionServices)
  {
    setModelName(NAME);
    this.connectionServices = connectionServices;
  }
  
  public void requestUpdate()
  {
    connectionServices.postCommand(Request.MESSAGE_TYPE_GET_PROPERTIES, "Get properties data", "");
  }
  
  @Override
  public void newMessage(int type, Object message)
  {
    if(type == Request.MESSAGE_TYPE_PROPERTIES)
    {
      String[] data = ((String) message).split(";");
      Vector<String> props = new Vector<String>();
      for(int k = 0; k < data.length; k++) {
        props.add(data[k]);
      }
      this.properties = props;
    
      // Tell all listeners that all content has to be reloaded.
      for(int k = 0; k < listeners.size(); k++) {
        ListDataListener listener = listeners.elementAt(k);
        listener.contentsChanged(new ListDataEvent(this, ListDataEvent.CONTENTS_CHANGED, 0, getSize() - 1));
      }    
    }
  }

  public void addListDataListener(ListDataListener l) {
    listeners.add(l);
  }

  public Object getElementAt(int index) {
    return properties.elementAt(index);
  }

  public int getSize() {
    return properties.size();
  }

  public void removeListDataListener(ListDataListener l) {
    listeners.remove(l);
  }
}
