package se.lth.cs.dkinterface.model;

import java.util.Vector;

import javax.swing.ListModel;
import javax.swing.event.ListDataEvent;
import javax.swing.event.ListDataListener;

import se.lth.cs.dkinterface.services.connection.ConnectionListener;
import se.lth.cs.dkinterface.services.connection.ConnectionServices;
import se.lth.cs.dkserver.model.device.DeviceStatus;
import se.lth.cs.dkserver.services.server.command.Request;

public class ResultsListModel implements ListModel, ConnectionListener {

  private final Vector listeners = new Vector();
  //private Vector results = new Vector();
  private Vector<DeviceStatus> results = new Vector<DeviceStatus>();
  
  private final ConnectionServices connectionServices;
  
  public ResultsListModel(ConnectionServices connectionServices) {
    this.connectionServices = connectionServices;
  }
  
//  public void reload(Vector<String> results) {
//    this.results = results;
//    
//    // Tell all listeners that all content has to be reloaded.
//    for(int k = 0; k < listeners.size(); k++) {
//      ListDataListener listener = (ListDataListener) listeners.elementAt(k);
//      listener.contentsChanged(new ListDataEvent(this, ListDataEvent.CONTENTS_CHANGED, 0, getSize() - 1));
//    }
//  }
  
  public void reload(Vector<DeviceStatus> results) {
    this.results = results;
    
    // Tell all listeners that all content has to be reloaded.
    for(int k = 0; k < listeners.size(); k++) {
      ListDataListener listener = (ListDataListener) listeners.elementAt(k);
      listener.contentsChanged(new ListDataEvent(this, ListDataEvent.CONTENTS_CHANGED, 0, getSize() - 1));
    }
  }  
  
  public void addListDataListener(ListDataListener l) {
    listeners.add(l);
  }

  public Object getElementAt(int index) {
    return results.elementAt(index);
  }

  public int getSize() {
    return results.size();
  }

  public void removeListDataListener(ListDataListener l) {
    listeners.remove(l);
  }

  public void requestRefreshResults()
  {
    connectionServices.postCommand(Request.MESSAGE_TYPE_GET_RESULTS, "Get result data", "");
  }
  
  @Override
  public void newMessage(int type, Object message)
  {
    if(type == Request.MESSAGE_TYPE_RESULTS)
    {
//      String[] data = ((String) message).split(";");
//      Vector<String> res = new Vector<String>();
//      for(int k = 0; k < data.length; k++) {
//        res.add(data[k]);
//      }
//      reload(res);
      
      Vector<DeviceStatus> deviceResults = (Vector<DeviceStatus>) message;
      reload(deviceResults);
      
    }
  }

}
