package se.lth.cs.dkinterface.services;

import java.io.EOFException;
import java.io.ObjectInputStream;
import java.util.Vector;

import se.lth.cs.dkinterface.util.Dbg;
import se.lth.cs.dkserver.services.server.command.Request;

public class ConnectionReader implements Runnable 
{
  private final ObjectInputStream in;
  private final Vector<Request> inbox;

  public ConnectionReader(ObjectInputStream in, Vector<Request> inbox) 
  {
    this.in = in;
    this.inbox = inbox;
  }

  @Override
  public void run() 
  {
    Request incoming;    
    try 
    {
      while((incoming = (Request) in.readObject()) != null) 
      {
        if(incoming.type != Request.MESSAGE_TYPE_LOG_ENTRY)
        {
          Dbg.println("[CLI] ConnectionReader.run(): Read message of type: " + incoming.type + " (" + incoming.info + ")");
        }
        inbox.add(incoming);
      }
    } 
    catch(EOFException eof)
    {
      Dbg.println("EOFException!");
    }
    catch(Exception e) 
    {
      Dbg.println("[CLI] ConnectionReader.run():" + e.toString());
      Dbg.println("[CLI] ConnectionReader.run(): ReaderThread error!");
    } 
  }
}
