package se.lth.cs.dkinterface.services;

import java.io.ObjectOutputStream;
import java.util.Vector;

import se.lth.cs.dkinterface.util.Dbg;
import se.lth.cs.dkserver.services.server.command.Request;

public class ConnectionWriter implements Runnable 
{
  private final ObjectOutputStream out;
  private final Vector<Request> outbox;
  
  public ConnectionWriter(ObjectOutputStream out, Vector<Request> outbox) 
  {
    this.out = out;
    this.outbox = outbox;
  }
  
  @Override
  public void run() 
  {
    try 
    {      
      while(true) 
      {
        if(outbox.size() > 0) 
        {
          Dbg.println("[CLI] ConnectionWriter.run(): Writing message of type: " + outbox.elementAt(0).type + " (" + outbox.elementAt(0).info + ")");
          out.writeObject(outbox.remove(0));
        } 
        else 
        {
          try 
          {
            Thread.sleep(200);
          } 
          catch(Exception e) {
            Dbg.println("[CLI] ConnectionWriter.run():" + e.toString()); 
            e.printStackTrace();
          }
        }
      }
    } 
    catch(Exception e) 
    {
      Dbg.println("[CLI] ConnectionWriter.run():" + e.toString());
      Dbg.println("[CLI] ConnectionWriter.run(): WriterThread error!");
    }
  }
}

