package se.lth.cs.dkinterface.view.base;

import javax.swing.JPanel;

public abstract class AbstractView extends JPanel
{
  private boolean active;
  private String viewName;
  
  protected void setViewName(String name)
  {
    viewName = name;
  }
  
  public String getViewName()
  {
    return viewName;
  }
  
  public boolean isActive()
  {
    return active;
  }
  
  public void setActivated(boolean active)
  {
    if(active)
    {
      activated();
    }
    if(!this.active && active)
    {
      this.active = active;
      activated();
    }
    else if(this.active && !active)
    {
      this.active = active;
      deactivated();
    }
  }
  
  protected abstract void activated();
  
  protected abstract void deactivated();
}
