package se.lth.cs.dkinterface.view.base;

import java.awt.Container;
import java.awt.Dimension;
import java.awt.Toolkit;
import java.util.Enumeration;
import java.util.Vector;

import javax.swing.JComponent;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JRootPane;
import javax.swing.JSplitPane;
import javax.swing.JTextArea;
import javax.swing.SpringLayout;
import javax.swing.UIManager;

import se.lth.cs.dkinterface.view.base.listview.ListView;

public class Screen extends JFrame
{
  public static final int INITIAL_WIDTH  = 1024;
  public static final int INITIAL_HEIGHT = 600;

  private ListView display;
  
  public Screen(ListView display)
  {
    super("Knowledge Server Interface");
    this.display = display;
    
    JFrame.setDefaultLookAndFeelDecorated(true);
    setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
    
    Container contentPane = getContentPane();
    
    SpringLayout layout = new SpringLayout();
    contentPane.setLayout(layout);

    contentPane.add(display);

    layout.putConstraint(SpringLayout.WEST, display, 3, SpringLayout.WEST, contentPane);
    layout.putConstraint(SpringLayout.NORTH, display, 3, SpringLayout.NORTH, contentPane);
    layout.putConstraint(SpringLayout.EAST, contentPane, 3, SpringLayout.EAST, display);
    layout.putConstraint(SpringLayout.SOUTH, contentPane, 3, SpringLayout.SOUTH, display);    
    
    contentPane.setPreferredSize(new Dimension(INITIAL_WIDTH, INITIAL_HEIGHT));
    Dimension dim = (Toolkit.getDefaultToolkit()).getScreenSize();
    setLocation((int) (dim.width/2 - INITIAL_WIDTH/2), (int) (dim.height/2 - INITIAL_HEIGHT/2)-50);
    pack();    
  }
  
  public void addView(AbstractView view)
  {
    display.addView(view);
  }
  
  
}
