package se.lth.cs.dkinterface.view.base.listview;

import java.awt.Component;
import java.awt.Font;

import javax.swing.BorderFactory;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.ListCellRenderer;

public class ListViewCellRenderer extends JLabel implements ListCellRenderer {

  public ListViewCellRenderer() {
    setOpaque(true);
  }
  
  public Component getListCellRendererComponent(JList list, Object object, int index, boolean isSelected, boolean cellHasFocus) {
    if (isSelected) {
      setBackground(list.getSelectionBackground());
      setForeground(list.getSelectionForeground());
    } else {
      setBackground(list.getBackground());
      setForeground(list.getForeground());
    }

    setHorizontalAlignment(JLabel.CENTER);
    setBorder(BorderFactory.createEtchedBorder());
    setText(object.toString());
    setFont(new Font("", Font.BOLD, 14));
    return this;
  }

}
