package se.lth.cs.dkinterface.view.components;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JList;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.ListSelectionModel;
import javax.swing.ScrollPaneConstants;

import net.miginfocom.swing.MigLayout;
import se.lth.cs.dkinterface.model.LibraryModel;

public class LibraryList extends JPanel implements ActionListener 
{
  JButton refreshButton, reloadLibButton;
  LibraryModel libraryModel;
  JList theList;
  
  public LibraryList(String title, LibraryModel libraryModel, int width, int height) 
  {
    this.libraryModel = libraryModel;
    theList = new JList(libraryModel);
    theList.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
    theList.getSelectedIndex();

    MigLayout layout = new MigLayout();
    setLayout(layout);        
    setBorder(BorderFactory.createTitledBorder(title));

    JScrollPane listScroller = new JScrollPane(theList);
    listScroller.setVerticalScrollBarPolicy(ScrollPaneConstants.VERTICAL_SCROLLBAR_ALWAYS);
    add(listScroller, "width 400::, height 300::");

    ButtonPanel buttonPanel = new ButtonPanel();
    add(buttonPanel, "height 100%, width 200::");            
  }
  
  class ButtonPanel extends JPanel implements ActionListener
  {
    private JButton deleteButton;
    
    public ButtonPanel()
    {
      MigLayout layout = new MigLayout("alignx left, aligny top, insets 20");
      setLayout(layout);
      
      deleteButton = new JButton("Delete selected");
      deleteButton.addActionListener(this);
      
      add(deleteButton, "width 150::, height 25::, wrap 15");
    }
    
    public void actionPerformed(ActionEvent e) 
    {
      if(e.getSource() == deleteButton) 
      {
        if(!theList.isSelectionEmpty() && theList.getSelectedIndex() >= 0 && theList.getSelectedIndex() < theList.getModel().getSize())
        {
          String entry = (String) theList.getSelectedValue();
          String loc = entry.substring(0, entry.indexOf("|"));
          String parser = entry.substring(entry.indexOf("|") + 1);
          loc = loc.trim();
          parser = parser.trim();
          
          libraryModel.deleteLocation(loc, parser);
        }
      }
    }    
  }
  
  public void actionPerformed(ActionEvent e) 
  {
    if(e.getSource() == refreshButton) 
    {
      libraryModel.requestLibraryUpdate();
    } 
    else if(e.getSource() == reloadLibButton) 
    {
      libraryModel.requestLibraryReload();
    }  
  }
  
}