package se.lth.cs.dkinterface.view.components;

import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.util.Vector;

import javax.swing.BorderFactory;
import javax.swing.JList;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.ListModel;
import javax.swing.ListSelectionModel;

import net.miginfocom.swing.MigLayout;
import se.lth.cs.dkinterface.view.ClickListener;

public class ScrollingList extends JPanel 
{
  private final JList theList;
  private final Vector<ClickListener> clickListeners;

  public ScrollingList(String title, ListModel model) 
  {
    MigLayout layout = new MigLayout("aligny top");
    setLayout(layout);
    
    clickListeners = new Vector<ClickListener>();
    theList = new JList(model);
    theList.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
    theList.addMouseListener(new ClickHandler(theList));
    JScrollPane listScroller = new JScrollPane(theList);
    setBorder(BorderFactory.createTitledBorder(title));    

    add(listScroller, "width 100%, height 100%");
  }

  public JList getList() {
    return theList;
  }

  public void addClickListener(ClickListener listener)
  {
    clickListeners.add(listener);
  }
  
  public class ClickHandler extends MouseAdapter
  {
    private final JList list;

    public ClickHandler(JList list)
    {
      this.list = list;
    }

    @Override
    public void mouseClicked(MouseEvent e)
    {
      if(e.getClickCount() == 2)
      {
        int index = list.locationToIndex(e.getPoint());
        ListModel dlm = list.getModel();
        Object item = dlm.getElementAt(index);;
        list.ensureIndexIsVisible(index);
        for(ClickListener l : clickListeners)
        {
          l.indexClicked(item);
        }
      }
    }

  }

}
