package se.lth.cs.dkinterface.view.components;

import java.awt.Color;
import java.awt.Component;
import java.awt.Font;

import javax.swing.BorderFactory;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JPanel;
import javax.swing.ListCellRenderer;

import net.miginfocom.swing.MigLayout;
import se.lth.cs.dkserver.model.device.DeviceStatus;

public class VerificationCellRenderer implements ListCellRenderer {
  
  public Component getListCellRendererComponent(JList list, Object object, int index, boolean isSelected, boolean cellHasFocus) {
    JPanel listEntry = new JPanel();
//    SpringLayout layout = new SpringLayout();
//    listEntry.setLayout(layout);
    MigLayout migLayout = new MigLayout("aligny top");
    listEntry.setLayout(migLayout);
    
    listEntry.setOpaque(true);

    listEntry.setBorder(BorderFactory.createLineBorder(Color.BLACK));
    
    DeviceStatus deviceStatus = (DeviceStatus) object;
    JLabel name = new JLabel(deviceStatus.getDeviceName() + " (" + deviceStatus.getDeviceType() + ")");
    name.setFont(new Font("", Font.BOLD, 14));
    listEntry.add(name, "wrap");
    
    if(deviceStatus.getMissingRequired().size() < 1)
    {
      listEntry.setBackground(new Color(0xA1DFAF));
      JLabel success = new JLabel("Successfully verified!");
      listEntry.add(success, "wrap");      
    }
    else
    {
      listEntry.setBackground(new Color(0xD76685));
      for(String missingRequired : deviceStatus.getMissingRequired())
      {
        JLabel failure = new JLabel("Missing required property: " + missingRequired);
        listEntry.add(failure, "wrap");
      }
    }
    
    if (isSelected) {
      listEntry.setBackground(list.getSelectionBackground());
      //listEntry.setBackground(new Color(0x7CA5D4));
      listEntry.setForeground(list.getSelectionForeground());
    } else {
//      listEntry.setBackground(list.getBackground());
//      listEntry.setForeground(list.getForeground());
    }    
    
    
//    JLabel text1 = new JLabel(object.toString());
//    listEntry.add(text1);
//    layout.putConstraint(SpringLayout.NORTH, text1, 2, SpringLayout.NORTH, listEntry);
//    layout.putConstraint(SpringLayout.WEST, text1, 2, SpringLayout.WEST, listEntry);
//    
//    JLabel text2 = new JLabel("-----");
//    listEntry.add(text2);
//    layout.putConstraint(SpringLayout.NORTH, text2, 2, SpringLayout.SOUTH, text1);
//    layout.putConstraint(SpringLayout.WEST, text2, 2, SpringLayout.WEST, listEntry);    
//    
//    listEntry.setPreferredSize(new Dimension(300,50));
    
    return listEntry;
  }

}
