package se.lth.cs.dkserver.services.server;

import java.io.ObjectInputStream;
import java.util.Vector;

import se.lth.cs.dkserver.services.server.command.Request;
import se.lth.cs.dkserver.util.Dbg;

public class ConnectionReader implements Runnable 
{  
  private final ObjectInputStream in;
  private final Vector<Request> inbox;
  
  public ConnectionReader(ObjectInputStream in, Vector<Request> inbox) 
  {
    this.in = in;
    this.inbox = inbox;
  }
  
  @Override
  public void run() 
  {
    Request incoming;    
    try 
    {
      while((incoming = (Request) in.readObject()) != null) 
      {
        Dbg.println("[SERV] ConnectionReader.run(): Read message of type: " + incoming.type + " (" + incoming.info + ")");
        inbox.add(incoming);
      }
    } 
    catch(Exception e) 
    {
      Dbg.println("[SERV] ConnectionReader.run(): " + e.toString());
      e.printStackTrace();
      Dbg.println("[SERV] ConnectionReader.run(): ReaderThread error!");
    } 
  }
}
