package se.lth.cs.dkserver.services.server;

import java.io.ObjectOutputStream;
import java.util.Vector;

import se.lth.cs.dkserver.services.server.command.Request;
import se.lth.cs.dkserver.util.Dbg;

public class ConnectionWriter implements Runnable 
{
  private final ObjectOutputStream out;
  private final Vector<Request> outbox;
  
  public ConnectionWriter(ObjectOutputStream out, Vector<Request> outbox) 
  {
    this.out = out;
    this.outbox = outbox;
  }
  
  @Override
  public void run() 
  {
    try 
    {      
      while(true) 
      {
        if(outbox.size() > 0) 
        {
          //System.out.println("[SERV] ConnectionWriter.run(): Writing message of type: " + outbox.elementAt(0).type + " (" + outbox.elementAt(0).info + ")");
          out.writeObject(outbox.remove(0));
        } 
        else 
        {
          try 
          {
            Thread.sleep(200);
          } 
          catch(Exception e) 
          { 
            Dbg.println(e.toString()); 
          }
        }
      }
    } 
    catch(Exception e) 
    {
      Dbg.println(e.toString());
      Dbg.println("[SERV] ConnectionWriter.run(): WriterThread error!");
    }
  }
}

